(function($){
    'use strict';
var GluedInSDKObject = window.GluedIn;
var GluedInSDKInitilizeObj = new GluedInSDKObject.GluedInSDKInitilize;
var GluedInSDKAuthObj = new GluedInSDKObject.GluedInAuthModule;
var currentVideosList = [];

$(document).ready(function(){
	
    $(".screen-loader").hide();
	let storedVideos = sessionStorage.getItem("videoUrl");

	if(storedVideos == "" || storedVideos == undefined || storedVideos == null) {
		history.back();
		return;
	}
	currentVideosList = JSON.parse(storedVideos);
	displaySelectVideo(currentVideosList);
	$(".dropzone").change(function(){
		readFile(this);	  
	});
	function readFile(input) {
	  
	  if(input.files && input.files) {
	  	var inputfile = input.files[0];
	  	
		if(inputfile.type != "video/mp4" && inputfile.type != "video/mpeg") {
			return false;
		}
	    var reader = new FileReader();

	    reader.onload = async function(e) {
	    	$(".image-upload-loader").show();
	    	let signedUrlResponse = await getSignedUrl();
	    	if(signedUrlResponse.status == 200) {
	    		let signedUrl = signedUrlResponse.data.data.uploadUrl;
	    		
	    		let videoUrl = signedUrlResponse.data.data.url;
	    		var file = inputfile;
	    		var requestOptions = {
				method: 'PUT',
				body: file,
				redirect: 'follow'
				};
				fetch(signedUrl, requestOptions)
				.then((response) => {
					$(".image-upload-loader").hide();
					currentVideosList.push(videoUrl);
					displaySelectVideo(currentVideosList);
				}).then(result => console.log(result))
				.catch(error => console.log('error', error));
	    		
	    		/*return;
	    		
	    		let uploadFile = await uploadVideoContent(signedUrl, e.target.result[0]);
	    		*/
	    		

	    	}
	    };

	    reader.readAsDataURL(input.files[0]);
	  }
	}

	async function getSignedUrl(){
		var feedModuleObj = new GluedIn.GluedInFeedModule;	
		let feedModuleResponse = await feedModuleObj.getSignedUrl({type: "video"});
		return feedModuleResponse;
		
	}

	async function getCategoryList(){
		var feedModuleObj = new GluedIn.GluedInFeedModule;	
		let feedModuleResponse = await feedModuleObj.getCategoryList({search: "",limit:100, offset:1});
		if(feedModuleResponse.status == 200){
			let categoryList = feedModuleResponse.data.data;
			var categoryOptions = '<option value="" selected disabled hidden>Choose Category</option>';
			if(categoryList.length > 0) {
				for(let i = 0; i < categoryList.length; i++) {
					categoryOptions += '<option value="'+categoryList[i].categoryId+'">'+categoryList[i].categoryName+'</option>';
				}
			}
			$(".category-dropdown").html(categoryOptions);
		}
		
	}
	getCategoryList();

	$(document).on("click", ".upload-content", async function() {
		$(".error-alert").remove();
		$(".success-alert").remove();
		let validateInput = validateInputForm();
		if(!validateInput){
			return;
		}
		if(currentVideosList.length == 0){
			alert("Please select media content");
			return;
		}
		$(".content-upload-loader").show();
		var obj = $(".creat-box-02-form");
		let formData = {
			  //"userId": "string",
			  
			  "s3Url": currentVideosList[0],
			  "title": obj.find("input[name=title]").val().trim(),
			  "description": obj.find("textarea[name=description]").val(),
			  "visibility": "Public",
			  "follow": true,
			  "type": "camera-upload",
			  "categoryId": obj.find("select[name=category]").val(),
			  "categoryName": obj.find("select[name=category] option:selected").text(),
			  "contentUrl": [
			    {
			      "type": "video",
			      "urls": currentVideosList
			    }
			  ]
			}

		var feedModuleObj = new GluedIn.GluedInFeedModule;	
		let feedModuleResponse = await feedModuleObj.uploadContent(formData);
		if(feedModuleResponse.status == 200 || feedModuleResponse.status == 201) {
			$(".content-upload-loader").hide();
			$('<div class="alert alert-success success-alert" role="alert">	'+feedModuleResponse.data.message+'</div>').insertBefore(".first-input-box");
			sessionStorage.removeItem("videoUrl");
			window.location.href = "/";
		}
		else {
			$(".content-upload-loader").hide();
			$('<div class="alert alert-danger error-alert" role="alert">	'+feedModuleResponse.data.message+'</div>').insertBefore(".first-input-box");
		}
		return feedModuleResponse;
	});

	function displaySelectVideo(selectedVideoList) {
		var videoListHtml = '';
		if(selectedVideoList.length > 0) {
			$(".img-sec .img-box").html('<video src="'+selectedVideoList[0]+'" class="full"></video>')
		}
		for(let i =0; i < selectedVideoList.length; i++) {
			videoListHtml += '<li><div class="inner-box"><video src="'+selectedVideoList[i]+'"></video></div><span class="remove-video" data-index="'+i+'"><i class="fa fa-times"></i></span></li>';
		}

		if(videoListHtml != "") {
			videoListHtml += '<li class="upload-content-block"><div class="inner-box"><img src="assets/images/creat-add.svg"><input type="file" name="" class="file-upload-btn-input dropzone" accept=".mp4,.mpeg,.avi" ></div></li>';
			$(".creat-add-btn ul").html(videoListHtml);
		}
		else{
			videoListHtml = '<li class="upload-content-block"><div class="inner-box"><img src="assets/images/creat-add.svg"><input type="file" name="" class="file-upload-btn-input dropzone" accept=".mp4,.mpeg,.avi" ></div></li>';			$(".creat-add-btn ul").html(videoListHtml);
		}

	}

	$(document).on("click", ".remove-video", function() {
		var videoIndex = $(this).attr("data-index");
		$(this).closest("li").remove();
		currentVideosList.splice(videoIndex, 1);
		if(videoIndex == 0) {
			$(".img-sec .upload-content").html('<img src="assets/images/shutterstock_206029852.png" class="full">');
		}
	})

	function validateInputForm() {
		let isValid = true;
		let error_message = [];
		var obj = $(".creat-box-02-form");
		obj.find(".error_message").remove();
		if(obj.find("input[name=title]").val().trim() == "") {
			$('<label class="error_message">Title is required</label>').insertAfter(obj.find("input[name=title]"));
			isValid = false;
		}
		if(obj.find("textarea[name=description]").val().trim() == "") {
			$('<label class="error_message">Description is required</label>').insertAfter(obj.find("textarea[name=description]"));
			isValid = false;
		}
		if(obj.find("select[name=category]").val() == "" || obj.find("select[name=category]").val() == null) {
			$('<label class="error_message">Category is required</label>').insertAfter(obj.find("select[name=category]"));
			isValid = false;
		}
		if(!obj.find("input[name=term_cond]").prop("checked")) {
			$('<label class="error_message">Please select term and conditions</label>').insertAfter(obj.find("input[name=term_cond]"));
			isValid = false;
		}
		return isValid;
	}


});
})(jQuery);
