(function ($) {
  "use strict";
  var GluedInSDKObject = window.GluedIn;
  var GluedInSDKInitilizeObj = new GluedInSDKObject.GluedInSDKInitilize();
  var GluedInSDKAuthObj = new GluedInSDKObject.GluedInAuthModule();
  var currentVideosList = [];

  $(document).ready(function () {
    $(".screen-loader").hide();
    const dropArea = document.querySelector(".dropzone-wrapper"),
      dragText = dropArea.querySelector("header"),
      button = dropArea.querySelector("button"),
      input = dropArea.querySelector("input");

    dropArea.addEventListener("dragover", (event) => {
      event.preventDefault(); //preventing from default behaviour
      dropArea.classList.add("active");
    });
    //If user leave dragged File from DropArea
    dropArea.addEventListener("dragleave", () => {
      dropArea.classList.remove("active");
    });
    //If user drop File on DropArea
    dropArea.addEventListener("drop", (event) => {
      event.preventDefault(); //preventing from default behaviour
      //getting user select file and [0] this means if user select multiple files then we'll select only the first one

      readFile(event.dataTransfer);
    });
    $(".dropzone").change(function () {
      readFile(this);
    });
    function readFile(input) {
      if (input.files && input.files) {
        var inputfile = input.files[0];

        if (inputfile.type != "video/mp4" && inputfile.type != "video/mpeg") {
          return false;
        }
        var reader = new FileReader();

        reader.onload = async function (e) {
          $(".image-upload-loader").show();
          let signedUrlResponse = await getSignedUrl();
          if (signedUrlResponse.status == 200) {
            let signedUrl = signedUrlResponse.data.data.uploadUrl;

            let videoUrl = signedUrlResponse.data.data.url;
            var file = inputfile;
            var requestOptions = {
              method: "PUT",
              body: file,
              redirect: "follow",
            };
            fetch(signedUrl, requestOptions)
              .then((response) => {
                $(".image-upload-loader").hide();
                console.log(response);
                response.text();
                let finalVideoUrlList = [];
                finalVideoUrlList.push(videoUrl);
                sessionStorage.setItem(
                  "videoUrl",
                  JSON.stringify(finalVideoUrlList)
                );
                window.location.href = "creat-page-02.html";
              })
              .then((result) => {
                console.log(result);
                $(".image-upload-loader").hide();
              })
              .catch((error) => {
                console.log("error", error);
                $(".image-upload-loader").hide();
              });
          } else {
            alert(signedUrlResponse.data.message);
            if (signedUrlResponse.status == 401) {
              localStorage.clear();
              sessionStorage.clear();
              window.location.href =
                "https://gluedin.io/web-app//sign-in.html";
            }
          }
        };

        reader.readAsDataURL(input.files[0]);
      }
    }

    async function getSignedUrl() {
      var feedModuleObj = new GluedIn.GluedInFeedModule();
      let feedModuleResponse = await feedModuleObj.getSignedUrl({
        type: "video",
      });
      return feedModuleResponse;
    }

    async function uploadVideoContent(signedUrl, inputfile) {
      var settings = {
        url: signedUrl,
        method: "PUT",
        timeout: 0,
        headers: {
          "Content-Type": "video/mp4",
        },
        data: inputfile,
      };

      $.ajax(settings).done(function (response) {
        debugger;
        console.log(response);
      });
      /*$.ajax({
	      type: 'PUT',
	      url: signedUrl,
	      // Content type must much with the parameter you signed your URL with
	      contentType: 'binary/octet-stream',
	      // this flag is important, if not set, it will try to send data as a form
	      processData: false,
	      // the actual file is sent raw
	      data: inputfile,
	      success: function(response){
	      	debugger;
	      	alert('File uploaded');
	      },
	      error: function(error){
	      	debugger;
	      	alert("File NOT uploaded")
	      } 
	    })*/
    }
  });
})(jQuery);
