(function ($) {
  "use strict";
  var GluedInSDKObject = window.GluedIn;
  var GluedInSDKInitilizeObj = new GluedInSDKObject.GluedInSDKInitilize();
  var GluedInSDKAuthObj = new GluedInSDKObject.GluedInAuthModule();
  var rails_video = {};
  var currentVideosList = [];
  var windowWidth = window.screen.width;
  var profileCharacter = windowWidth > 501 ? 8 : 5;
  $(document).ready(function () {
    $(".screen-loader").show();
    window.getDiscoverContent = async function () {
      var discoverModuleObj = new GluedIn.GluedInDiscover();
      var challengesModuleObj = new GluedIn.GluedInChallenges();
      var hashtagModuleObj = new GluedIn.GluedInHashTag();
      var params = new URL(document.location).searchParams;
      var searchKeyword = params.get("search");
      $("input[name='search']").val(searchKeyword);
      var topProfileData = await discoverModuleObj.getDiscoverTopProfiles({
        search: searchKeyword,
      });

      var allVideos = await discoverModuleObj.getDiscoverAllVideos({
        search: searchKeyword,
        limit: 10,
        offset: 1,
      });

      var hashtagsData = await hashtagModuleObj.getHashTagList({
        search: searchKeyword,
        limit: 10,
        offset: 1,
      });

      var challengesData = await challengesModuleObj.getChallengesList({
        title: searchKeyword,
        limit: 10,
        offset: 1,
      });

      $(".screen-loader").hide();

      if (topProfileData.status == 200) {
        let topProfileHtml = "";
        let topProfileHtmlSliderItem = "";
        topProfileData.data.data.forEach(function (profileInfo) {
          let fullName =
            profileInfo.fullName.length > profileCharacter
              ? profileInfo.fullName.substr(0, profileCharacter) + ".."
              : profileInfo.fullName;
          topProfileHtml +=
            '<div class="col-md-2 box text-center"><a href="profile-details/' +
            profileInfo.userId +
            '"><div class="img-box"><img src="' +
            profileInfo.profileImageUrl +
            '" class="full"></div><h5>' +
            fullName +
            "</h5><h6>" +
            profileInfo.followersCount +
            " Followers</h6></div></div>";
          topProfileHtmlSliderItem +=
            '<div class="box text-center"><a href="profile-details/' +
            profileInfo.userId +
            '"><div class="img-box"><img src="' +
            profileInfo.profileImageUrl +
            '" class="full"></div><h5>' +
            fullName +
            "</h5><h6>" +
            profileInfo.followersCount +
            " Followers</h6></div></div>";
          //topProfileHtmlSliderItem += '<li class="item"><a href="profile-details/'+profileInfo.userId+'"><img src="'+profileInfo.profileImageUrl+'"><span class="sml-text">'+profileInfo.fullName+'</span></a></li>';
        });
        $(".top-profile-item-list").html(topProfileHtmlSliderItem);
        $(".top-profile-row-item").html(topProfileHtml);
        if (topProfileHtml == "") {
          $(".profile-section").hide();
          $("#tab2").hide();
        }
        $(".profile-box-slider-02").owlCarousel({
          loop: true,
          items: 6,
          autoplay: true,
          autoplayTimeout: 5000,
          video: true,
          autoHeight: false,
          autoplaySpeed: 1000,
          margin: 0,
          autoplayHoverPause: true,
          nav: false,
          dots: false,
          margin: 15,
          responsive: {
            0: {
              items: 5,
              nav: false,
            },
            600: {
              items: 6,
              nav: false,
            },
            1000: {
              items: 6,
              nav: false,
              margin: 15,
              loop: false,
            },
          },
        });
      } else {
      }

      if (allVideos.status == 200) {
        let videoContentHtml = "";
        currentVideosList = allVideos.data.data.videos;
        allVideos.data.data.videos.forEach(function (videoInfo) {
          videoContentHtml +=
            '<div class="col-md-3 box text-center"><div class="img-box open-video-detail" data-id="' +
            videoInfo.videoId +
            '" style="background: url(' +
            videoInfo.thumbnailUrl +
            ') center; background-size: cover; max-height: 227px; height: 227px; border-radius:9px;"><span class="av-icon"><img src="assets/images/folder-icon.svg"></span></div></div>';
        });
        $(".video-row-item").html(videoContentHtml);
        if (videoContentHtml == "") {
          $(".video-section").hide();
          $("#tab5").hide();
        }
      } else {
      }

      if (hashtagsData.status == 200) {
        let hashtagHtml = "";
        hashtagsData.data.data.forEach(function (hashtagInfo) {
          hashtagHtml += '<li><a href="">#' + hashtagInfo.title + "</a></li>";
        });
        $(".hashtag-ul").html(hashtagHtml);
        if (hashtagHtml == "") {
          $(".hashtag-section").hide();
          $("#tab3").hide();
        }
      } else {
      }

      if (challengesData.status == 200) {
        $(".challenges-section").hide();
        $("#tab4").hide();
      } else {
      }
      let displayContent = 0;
      $("#tabs-nav")
        .find("li")
        .each(function () {
          if ($(this).css("display") != "none") displayContent++;
        });
      if (displayContent == 1) {
        $(".main-section").html("<p>No Records Found</p>");
      }
      $(".main-section").show();
    };

    getDiscoverContent();

    $(document).on("click", ".open-video-detail", function () {
      let videoId = $(this).attr("data-id");
      localStorage.setItem("selectedVideo", videoId);
      localStorage.setItem("contentType", "video");
      localStorage.setItem("videoList", JSON.stringify(currentVideosList));
      window.location.href = "https://gluedin.io/web-app//feed-detail.html";
    });

    $(document).on("click", ".view-category-details", async function () {
      var discoverModuleObj = new GluedIn.GluedInDiscover();

      var discoverModuleResponse =
        await discoverModuleObj.getDiscoverCategoryWiseVideo(
          $(this).attr("data-id")
        );

      if (discoverModuleResponse.status == 200) {
        if (discoverModuleResponse.data.data.length > 0) {
          let firstVideo = discoverModuleResponse.data.data[0];
          let videoId = firstVideo.videoId;
          localStorage.setItem("selectedVideo", videoId);
          localStorage.setItem("contentType", "video");
          localStorage.setItem(
            "videoList",
            JSON.stringify(discoverModuleResponse.data.data)
          );
          window.location.href =
            "https://gluedin.io/web-app//feed-detail.html";
        } else {
        }
      } else {
        if (discoverModuleResponse.status == 401) {
          localStorage.clear();
          sessionStorage.clear();
          window.location.href = "https://gluedin.io/web-app//sign-in.html";
        }
      }
    });
  });
})(jQuery);
