(function ($) {
  "use strict";
  var GluedInSDKObject = window.GluedIn;
  var GluedInSDKInitilizeObj = new GluedInSDKObject.GluedInSDKInitilize();
  var GluedInSDKAuthObj = new GluedInSDKObject.GluedInAuthModule();
  var currentVideosList = [];
  var rails_video = {};
  var allChallenges = [];
  var windowWidth = window.screen.width;
  var profileCharacter = windowWidth > 501 ? 8 : 5;
  $(document).ready(function () {
    $(".screen-loader").show();

    window.getDiscoverContent = async function () {
      var curatedContentModuleObj = new GluedIn.GluedInCuratedContentModule();

      var curatedContentModuleResponse =
        await curatedContentModuleObj.getCuratedContentList("discover");
      $(".screen-loader").hide();
      if (curatedContentModuleResponse.status == 200) {
        let sortedCuratedData = curatedContentModuleResponse.data.data.sort(
          function (a, b) {
            return a.position - b.position;
          }
        );

        sortedCuratedData.forEach(async function (curationData) {
          let curatedContentHtml = await bindCurationContent(curationData);
          $(".discover-content").append(curatedContentHtml);
          if (curationData.contentType == "video") {
            rails_video[curationData.railId] = curationData.itemList;
          }
          if (curationData.contentType == "user") {
            $(".profile-box-slider-02").owlCarousel({
              loop: true,
              items: 6,
              autoplay: true,
              autoplayTimeout: 5000,
              video: true,
              autoHeight: false,
              autoplaySpeed: 1000,
              margin: 0,
              autoplayHoverPause: true,
              nav: false,
              dots: false,
              margin: 15,
              responsive: {
                0: {
                  items: 5,
                  nav: false,
                },
                600: {
                  items: 6,
                  nav: false,
                },
                1000: {
                  items: 6,
                  nav: false,
                  margin: 15,
                  loop: false,
                },
              },
            });
          }

          if (curationData.contentType == "category") {
            $(".dance-box-slider").addClass("owl-theme owl-carousel");

            $(".dance-box-slider").owlCarousel({
              loop: true,
              items: 2.5,
              autoplay: true,
              autoplayTimeout: 5000,
              video: true,
              autoHeight: false,
              autoplaySpeed: 1000,
              margin: 0,
              autoplayHoverPause: true,
              nav: true,
              navText: [
                '<img src="assets/images/arrow-small-right.svg">',
                '<img src="assets/images/arrow-small-left-g.svg">',
              ],
              dots: false,
              margin: 15,
            });
          }

          if (curationData.contentType == "challenge") {
            $(".challenge-box-slider").addClass("owl-theme owl-carousel");

            $(".challenge-box-slider").owlCarousel({
              loop: true,
              items: 3,
              autoplay: true,
              autoplayTimeout: 5000,
              video: true,
              autoHeight: false,
              autoplaySpeed: 1000,
              margin: 0,
              autoplayHoverPause: true,
              nav: false,
              dots: false,
              margin: 15,
              responsive: {
                0: {
                  items: 2.5,
                  nav: false,
                },
                600: {
                  items: 3,
                  nav: false,
                },
                1000: {
                  items: 3,
                  loop: false,
                },
              },
            });
            var width = $(window).width();

            if (width < 770) {
              $(".challenge-box-slider").addClass("owl-theme owl-carousel");

              $(".challenge-box-slider").owlCarousel({
                loop: true,
                items: 2.5,
                autoplay: true,
                autoplayTimeout: 5000,
                video: true,
                autoHeight: false,
                autoplaySpeed: 1000,
                margin: 0,
                autoplayHoverPause: true,
                nav: true,
                navText: [
                  '<img src="assets/images/arrow-small-right.svg">',
                  '<img src="assets/images/arrow-small-left-g.svg">',
                ],
                dots: false,
                margin: 15,
              });
            }
          }

          if (curationData.contentType == "video") {
            var width = $(window).width();

            $(".arrival-box-slider").addClass("owl-theme owl-carousel");

            $(".arrival-box-slider").owlCarousel({
              loop: true,
              items: 4,
              autoplay: true,
              autoplayTimeout: 5000,
              video: true,
              autoHeight: false,
              autoplaySpeed: 1000,
              margin: 0,
              autoplayHoverPause: true,
              nav: true,
              navText: [
                '<img src="assets/images/arrow-small-right.svg">',
                '<img src="assets/images/arrow-small-left-g.svg">',
              ],
              dots: false,
              margin: 15,
              responsive: {
                0: {
                  items: 2.5,
                  nav: false,
                },
                600: {
                  items: 4.5,
                  nav: false,
                },
                1000: {
                  items: 4,
                  loop: false,
                },
              },
            });
          }

          if (curationData.contentType == "hashtag") {
            var width = $(window).width();

            $(".dance-box-slider").addClass("owl-theme owl-carousel");

            $(".dance-box-slider").owlCarousel({
              loop: true,
              items: 3,
              autoplay: true,
              autoplayTimeout: 5000,
              video: true,
              autoHeight: false,
              autoplaySpeed: 1000,
              margin: 0,
              autoplayHoverPause: true,
              nav: false,
              dots: false,
              margin: 15,
              responsive: {
                0: {
                  items: 2.5,
                  nav: false,
                },
                600: {
                  items: 3,
                  nav: false,
                },
                1000: {
                  items: 3,
                  loop: false,
                },
              },
            });
          }
          //$(curatedContentHtml).insertAfter(".discover-content");
        });
      } else {
        if (curatedContentModuleResponse.status == 401) {
          localStorage.clear();
          sessionStorage.clear();
          window.location.href = "https://gluedin.io/web-app//sign-in.html";
        }
      }
    };

    getDiscoverContent();

    function bindCurationContent(curationData) {
      let curatedContent = curationData.itemList;
      switch (curationData.contentType) {
        case "user":
          if (curatedContent.length > 0) {
            var topProfileHtml =
              '<div class="inner-box profile-box mt-t-45"><h4>' +
              curationData.railName +
              '</h4><div class="row"> <div class="profile-box-slider-02 owl-carousel owl-theme">';
            curatedContent.forEach(function (profileInfo) {
              let fullName =
                profileInfo.profile.fullName.length > profileCharacter
                  ? profileInfo.profile.fullName.substr(0, profileCharacter) +
                    ".."
                  : profileInfo.profile.fullName;

              topProfileHtml +=
                '<div class="box text-center"><a href="profile-details/' +
                profileInfo.profile.userId +
                '"><div class="img-box"><img src="' +
                profileInfo.profile.profileImageUrl +
                '" class="full"></div><h5>' +
                fullName +
                "</h5><h6>" +
                profileInfo.profile.followersCount +
                " Followers</h6></a></div>";
            });
            topProfileHtml += "</div></div> </div>";
          }
          return topProfileHtml;
          break;
        case "category":
          if (curatedContent.length > 0) {
            var categoryHtml =
              '<div class="inner-box cat-box mt-t-45"><h4>' +
              curationData.railName +
              '</h4><div class="row"> <div class="dance-box-slider">';
            curatedContent.forEach(function (categoryInfo) {
              categoryHtml +=
                '<div class=" box dance-box"><div class="img-box view-category-details" data-id="' +
                categoryInfo.id +
                '"><img src="' +
                categoryInfo.thumbnail +
                '"></div><h4>' +
                categoryInfo.displayName +
                "</h4></div>";
            });
            categoryHtml += "</div></div></div>";
          }
          return categoryHtml;
          break;
        case "video":
          if (curatedContent.length > 0) {
            var videoContentHtml =
              '<div class="inner-box arrival-box mt-t-45"><h4>' +
              curationData.railName +
              '</h4><div class="row"><div class="arrival-box-slider">';
            curatedContent.forEach(function (videoInfo) {
              videoContentHtml +=
                '<div class=" box text-center"><div class="img-box open-video-detail" id="' +
                videoInfo.id +
                '" railId="' +
                curationData.railId +
                '" style="background: url(' +
                videoInfo.thumbnail +
                ') center; background-size: cover; max-height: 227px; height: 227px; border-radius:9px;"><span class="av-icon"><img src="assets/images/folder-icon.svg"></span></div></div>';
            });
            videoContentHtml += "</div></div></div>";
          }
          return videoContentHtml;
          break;
        case "hashtag":
          if (curatedContent.length > 0) {
            var hashtagHtml =
              '<div class="inner-box hashtag-box mt-t-45"><ul class="head-part"><li><h4>' +
              curationData.railName +
              '</h4></li><li class="text-right"><a href=""><span>see all</span> <img src="assets/images/arrow-small-left.svg"></a></li></ul><ul class="hashtag-ul">';
            curatedContent.forEach(function (hashtagInfo) {
              hashtagHtml +=
                '<li><a href="javascript:void(0)" class="hashtag-detail" data-hashtag-name="' +
                hashtagInfo.hashtag.title +
                '">#' +
                hashtagInfo.hashtag.title +
                "</a></li>";
            });
            hashtagHtml += "</ul></div>";
          }
          return hashtagHtml;
          break;
        case "challenge":
          if (curatedContent.length > 0) {
            var challengeHtml =
              '<div class="inner-box cat-box mt-t-45"><h4>' +
              curationData.railName +
              '</h4><div class="row"> <div class="challenge-box-slider">';
            allChallenges = curatedContent;
            curatedContent.forEach(function (challengeInfo, index) {
              challengeHtml +=
                '<div class=" box dance-box"><div class="img-box view-challenge-details" data-id="' +
                challengeInfo.id +
                '" data-challengeInfo= "' +
                index +
                '"><img src="' +
                challengeInfo.thumbnail +
                '"></div><h4>' +
                challengeInfo.displayName +
                "</h4></div>";
            });
            challengeHtml += "</div></div></div>";
          }
          return challengeHtml;
          break;
        default:
          break;
      }
    }

    $(document).on("click", ".open-video-detail", function () {
      let videoId = $(this).attr("id");
      localStorage.setItem("selectedVideo", videoId);
      localStorage.setItem("contentType", "discover");
      let railId = $(this).attr("railId");
      localStorage.setItem("videoList", JSON.stringify(rails_video[railId]));
      window.location.href = "https://gluedin.io/web-app//feed-detail.html";
    });

    $(document).on("click", ".view-category-details", async function () {
      var discoverModuleObj = new GluedIn.GluedInDiscover();

      var discoverModuleResponse =
        await discoverModuleObj.getDiscoverCategoryWiseVideo(
          $(this).attr("data-id")
        );

      if (discoverModuleResponse.status == 200) {
        if (discoverModuleResponse.data.data.length > 0) {
          let firstVideo = discoverModuleResponse.data.data[0];
          let videoId = firstVideo.videoId;
          localStorage.setItem("selectedVideo", videoId);
          localStorage.setItem("contentType", "video");
          localStorage.setItem(
            "videoList",
            JSON.stringify(discoverModuleResponse.data.data)
          );
          window.location.href =
            "https://gluedin.io/web-app//feed-detail.html";
        } else {
        }
      } else {
        if (discoverModuleResponse.status == 401) {
          localStorage.clear();
          sessionStorage.clear();
          window.location.href = "https://gluedin.io/web-app//sign-in.html";
        }
      }
    });

    $(document).on("click", ".hashtag-detail", function () {
      let hashTagName = $(this).attr("data-hashtag-name");
      localStorage.setItem("selectedhashTagName", hashTagName);
      window.location.href =
        "https://gluedin.io/web-app//hashtag-detail.html";
    });

    $(document).on("click", ".view-challenge-details", function () {
      let challengeDetails = allChallenges[$(this).attr("data-challengeInfo")];
      localStorage.setItem(
        "selectedChallengeInfo",
        JSON.stringify(challengeDetails)
      );
      window.location.href =
        "https://gluedin.io/web-app//challenge-detail.html";
    });
  });
})(jQuery);
