(function ($) {
  "use strict";
  var GluedInSDKObject = window.GluedIn;
  var GluedInSDKInitilizeObj = new GluedInSDKObject.GluedInSDKInitilize();
  var GluedInSDKAuthObj = new GluedInSDKObject.GluedInAuthModule();
  var allVideoList = [];
  var currentIndex = -1;
  $(document).ready(function () {
    $(".screen-loader").show();
    window.bindFeedVideoHtml = async function (contentInfo) {
      let accessToken = GluedInSDKAuthObj.getAccessToken();

      let videoIds = [contentInfo.videoId];
      var feedModuleObj = new GluedIn.GluedInFeedModule();
      let videoLikedByUser = [];
      if (videoIds.length > 0) {
        if (accessToken) {
          let likeVideos = await feedModuleObj.Like(videoIds);
          if (likeVideos.status == 200) videoLikedByUser = likeVideos.data.data;
        }
      }
      $(".screen-loader").hide();


      let contentInfoDetails = contentInfo;
      let feedHtml = "";
      var activityTimelineModuleObj = new GluedIn.GluedInActivityTimeline();
      let previousCommentCountHtml = "";
      let feedModuleComment =
        await activityTimelineModuleObj.getActivityTimelineCommentList({
          limit: 5,
          offset: 1,
          topicId: contentInfo.videoId,
        });
      if (feedModuleComment.data.total > 5) {
        let commentCount = contentInfoDetails.commentCount - 5;
        previousCommentCountHtml =
          '<div class="text ft-500 view-previous-comment" data-comment-count="' +
          commentCount +
          '" data-assetId="' +
          contentInfo.videoId +
          '"><span class="comment-count " data-comment-count="' +
          commentCount +
          '" data-assetId="' +
          contentInfo.videoId +
          '">' +
          commentCount +
          "</span> View  previous comments</div>";
      }
      let commentHtml = await getCommentHtml(feedModuleComment.data);
      let likeByuser =
        videoLikedByUser.indexOf(contentInfo.videoId) > -1
          ? "active likedByUser"
          : "";
      let contentDescription = contentInfoDetails.description;
      if (contentDescription.length > 100) {
        contentDescription =
          contentDescription.substr(0, 100) +
          '<a href="javascript:void(0)" class="text-b show-more-content">Show More</a>' +
          ' <span class="show-more-content-section" style="display:none;">' +
          contentDescription.substr(100, contentDescription.length) +
          '</span> <a href="javascript:void(0)" class="text-b show-less-content" style="display:none;">Show Less</a>';
      }
      if (contentInfoDetails.contentType == "image") {
        let slideImages = "";
        contentInfoDetails.contentUrls.forEach(function (imageContent) {
          slideImages +=
            '<div class="item"><img src="' +
            imageContent.urls +
            '" class="full"></div>';
        });
        feedHtml +=
          '<div class="full-post-box ordering"><div class="post-box-parent col-md-7 first_div">  <div class="post-slider-box-parent"><div class="post-slider-box owl-carousel owl-theme">' +
          slideImages +
          '</div><div class="post-slider-box-bottom"><div class="strip">  <ul class="post-slider-box-bottom-ul">  <li><a href="javascript:void(0);" class="like-video ' +
          likeByuser +
          '" data-videoId="' +
          contentInfoDetails.videoId +
          '"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 33.899 30.435"><path id="Heart" d="M129.908,216.734a8.443,8.443,0,0,0-6.28-2.734,7.9,7.9,0,0,0-4.934,1.7,10.08,10.08,0,0,0-1.995,2.083A10.091,10.091,0,0,0,114.7,215.7a7.9,7.9,0,0,0-4.933-1.7,8.444,8.444,0,0,0-6.281,2.734,9.814,9.814,0,0,0-2.491,6.7,11.687,11.687,0,0,0,3.114,7.65,66.4,66.4,0,0,0,7.8,7.317c1.08.92,2.3,1.964,3.576,3.076a1.843,1.843,0,0,0,2.427,0c1.271-1.111,2.5-2.156,3.577-3.077a66.366,66.366,0,0,0,7.8-7.316,11.686,11.686,0,0,0,3.114-7.65,9.814,9.814,0,0,0-2.491-6.7Zm0,0" transform="translate(-99.75 -212.75)" fill="none" stroke="#777" stroke-width="2.5"/></svg><span class="like-count">' +
          contentInfoDetails.likeCount +
          '</span></a></li>  <li><a href=""><img src="assets/images/comment.svg"><span class="comment-count">' +
          contentInfoDetails.commentCount +
          '</span></a></li>  <li><a href=""><img src="assets/images/share.svg"></a></li>  </ul>  <!-- <a href="" class="dot-icon"><img src="assets/images/blue-dot.svg"></a> -->  </div>  <div class="comment-box-parent">  ' +
          previousCommentCountHtml +
          "  " +
          commentHtml +
          '  <div class="creat-comment-strip">  <div class="creat-comment-box">  <input type="text" name="post_comment" placeholder="Write a comment"> <input type="hidden" name="assestId" placeholder="assestId" value="' +
          contentInfoDetails.videoId +
          '">   <a href="javascript:void(0);" class="comment-submit">  <img src="assets/images/send-icon.svg">  </a>  </div>  </div>  </div></div></div></div><div class="col-md-5 post-detail-box-parent second_div"><div class="post-detail-box"><div class="top-details"><ul><li><div class="img-holder"><a href="profile-details/' +
          contentInfoDetails.userId +
          '"><img src="assets/images/mini-pro.png"></a></div></li><li><h3 class="ft-500"><a href="profile-details/' +
          contentInfoDetails.userId +
          '">' +
          contentInfoDetails.videoOwnerName +
          '</a></h3></li></ul><div class="c-text">' +
          contentInfoDetails.title +
          '</div><div class="sml-text mt-t-5">' +
          contentDescription +
          "</div></div><hr/>";
        if (contentInfoDetails.shoppable) {
          if (contentInfoDetails.products) {
            feedHtml +=
              '<div class="bottom-deatails"><div class="text">Shop</div><ul class="bottom-deatails-ul">';
            contentInfoDetails.products.forEach(function (productInfo) {
              let shoppableUrl = productInfo.shoppableLink
                ? productInfo.shoppableLink.indexOf("http://") < 0 &&
                  productInfo.shoppableLink.indexOf("https://") < 0
                  ? "http://" + productInfo.shoppableLink
                  : productInfo.shoppableLink
                : "";
              feedHtml +=
                '<li><div class="box"><div class="img-box"><img src="' +
                productInfo.imageUrl +
                '"></div><span cl>' +
                productInfo.productName +
                "</span><span cl>$" +
                productInfo.mrp +
                '</span><a href="' +
                shoppableUrl +
                '" target="_blank" class="text-b">Shop Now</a></div></li>';
            });
            feedHtml += "</ul></div>";
          }
        }
        feedHtml += "</div></div> </div>";
      } else {
        feedHtml +=
          '<div class="full-post-box ordering"><div class="post-box-parent col-md-7 first_div">  <div class="post-slider-box-parent"><div class="post-slider-box-02 video" style="background: #000;"><video width="100%" height="522" controls  poster="' +
          contentInfoDetails.thumbnailUrl +
          '"><source src="' +
          contentInfoDetails.contentUrls[0].urls[0] +
          '"  type="video/mp4">Your browser does not support the video tag.</video></div><div class="post-slider-box-bottom"><div class="strip">  <ul class="post-slider-box-bottom-ul">  <li><a href="javascript:void(0);" class="like-video ' +
          likeByuser +
          '" data-videoId="' +
          contentInfoDetails.videoId +
          '"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 33.899 30.435"><path id="Heart" d="M129.908,216.734a8.443,8.443,0,0,0-6.28-2.734,7.9,7.9,0,0,0-4.934,1.7,10.08,10.08,0,0,0-1.995,2.083A10.091,10.091,0,0,0,114.7,215.7a7.9,7.9,0,0,0-4.933-1.7,8.444,8.444,0,0,0-6.281,2.734,9.814,9.814,0,0,0-2.491,6.7,11.687,11.687,0,0,0,3.114,7.65,66.4,66.4,0,0,0,7.8,7.317c1.08.92,2.3,1.964,3.576,3.076a1.843,1.843,0,0,0,2.427,0c1.271-1.111,2.5-2.156,3.577-3.077a66.366,66.366,0,0,0,7.8-7.316,11.686,11.686,0,0,0,3.114-7.65,9.814,9.814,0,0,0-2.491-6.7Zm0,0" transform="translate(-99.75 -212.75)" fill="none" stroke="#777" stroke-width="2.5"/></svg><span class="like-count">' +
          contentInfoDetails.likeCount +
          '</span></a></li>  <li><a href=""><img src="assets/images/comment.svg"><span class="comment-count">' +
          contentInfoDetails.commentCount +
          '</span></a></li>  <li><a href=""><img src="assets/images/share.svg"></a></li>  </ul>  <a href="" class="dot-icon"><img src="assets/images/blue-dot.svg"></a>  </div>  <div class="comment-box-parent">  ' +
          previousCommentCountHtml +
          "  " +
          commentHtml +
          '  <div class="creat-comment-strip">  <div class="creat-comment-box">  <input type="text" name="post_comment" placeholder="Write a comment"> <input type="hidden" name="assestId" placeholder="assestId" value="' +
          contentInfoDetails.videoId +
          '">  <a href="javascript:void(0);" class="comment-submit">  <img src="assets/images/send-icon.svg">  </a>  </div>  </div>  </div></div></div></div><div class="col-md-5 post-detail-box-parent second_div"><div class="post-detail-box"><div class="top-details"><ul><li><div class="img-holder"><a href="profile-details/' +
          contentInfoDetails.userId +
          '"><img src="assets/images/mini-pro.png"></a></div></li><li><h3 class="ft-500"><a href="profile-details/' +
          contentInfoDetails.userId +
          '">' +
           contentInfoDetails.user.fullName +
          '</a></h3></li></ul><div class="c-text">' +
          contentInfoDetails.title +
          '</div><div class="sml-text mt-t-5">' +
          contentDescription +
          "</div></div><hr/>";
        if (contentInfoDetails.shoppable) {
          if (contentInfoDetails.products) {
            feedHtml +=
              '<div class="bottom-deatails"><div class="text">Shop</div><ul class="bottom-deatails-ul">';
            contentInfoDetails.products.forEach(function (productInfo) {
              let shoppableUrl = productInfo.shoppableLink
                ? productInfo.shoppableLink.indexOf("http://") < 0 &&
                  productInfo.shoppableLink.indexOf("https://") < 0
                  ? "http://" + productInfo.shoppableLink
                  : productInfo.shoppableLink
                : "";
              feedHtml +=
                '<li><div class="box"><div class="img-box"><img src="' +
                productInfo.imageUrl +
                '"></div><span cl>' +
                productInfo.productName +
                "</span><span cl>$" +
                productInfo.mrp +
                '</span><a href="' +
                shoppableUrl +
                '" class="text-b">Shop Now</a></div></li>';
            });
            feedHtml += "</ul></div>";
          }
        }
        feedHtml += "</div></div> </div>";
      }
      $(".profile-content-list").html(feedHtml);
      $(".feed-pagination-parent").show();
      $(".post-slider-box").owlCarousel({
        loop: true,
        items: 1,
        autoplay: true,
        autoplayTimeout: 5000,
        video: true,
        autoHeight: false,
        autoplaySpeed: 1000,
        margin: 0,
        singleItem: true,
        autoplayHoverPause: true,
        nav: false,
        dots: true,
        navText: [
          '<img src="assets/images/svg">',
          '<img src="assets/images/right-arrow.svg">',
        ],
      });
    };
    window.getBindVideoDetails = async function () {
      let videoId = localStorage.getItem("selectedVideo");
      let contentType = localStorage.getItem("contentType");

      if (videoId == "" || videoId == undefined) {
        /*window.location.href = "https://gluedin.io/web-app//profile.html";*/
      }
      let videoList = localStorage.getItem("videoList");

      if (videoList && videoList != undefined) {
        allVideoList = JSON.parse(videoList);
        console.log(allVideoList);
        let videoIndex = -1;
        if (contentType == "discover" || contentType == "activity-timeline") {
          videoIndex = allVideoList.map((item) => item.id).indexOf(videoId);
          console.log(
            "🚀 ~ file: feed-detail.js ~ line 217 ~ llVideoList.map((item) => item._id)",
            allVideoList.map((item) => item.id)
          );
        } else {
          videoIndex = allVideoList
            .map((item) => item.videoId)
            .indexOf(videoId);
        }
        if (videoIndex > -1) {
          currentIndex = videoIndex;
          let videoDetails = allVideoList[currentIndex];
          if (currentIndex == allVideoList.length - 1 && currentIndex != 0) {
            $(".previous-video").show();
            $(".next-video").hide();
          } else if (currentIndex == 0) {
            $(".previous-video").hide();
            if (currentIndex != allVideoList.length - 1) {
              $(".next-video").show();
            }
          } else {
            $(".previous-video").show();
            $(".next-video").show();
          }
          if (contentType == "discover") {
            videoDetails = videoDetails.video;
          } else if (contentType == "activity-timeline") {
            videoDetails = videoDetails;
          }
          bindFeedVideoHtml(videoDetails);
        } else {
          /*window.location.href = "https://gluedin.io/web-app//profile.html";*/
        }
      } else {
        /*window.location.href = "https://gluedin.io/web-app//profile.html";*/
      }
    };

    getBindVideoDetails();

    function getCommentHtml(commentData) {
      let commentHtmlList = "";
      if (commentData.data.length > 0) {
        for (let c of commentData.data) {
          commentHtmlList +=
            '<div class="comment-box mt-t-15"><ul><li class="img-li"><div class="img-holder"><a href="https://gluedin.io/web-app//profile-details/' +
            c.userId +
            '"><img src="' +
            c.profileImageUrl +
            '"></a></div></li><li class="content-li"><a href="https://gluedin.io/web-app//profile-details/' +
            c.userId +
            '"><h6 class=" text">' +
            c.fullName +
            '</h6></a><span class="text-blk">' +
            c.description +
            '</span><a href="" class=" text-g rply-more">View ' +
            c.replyCount +
            ' replies</a>  </li></ul><a href="" class="comment-dots"><img src="assets/images/hor-dot.svg"></a></div>';
        }
      }
      return commentHtmlList;
    }

    $(document).on("click", ".comment-submit", async function () {
      let userComment = $(this).closest("div").find("input:eq(0)").val();
      if (!userComment) return;

      let accessToken = GluedInSDKAuthObj.getAccessToken();
      if (
        accessToken == "" ||
        accessToken == undefined ||
        accessToken == null
      ) {
        $("#signupmodel").modal("show");
        return;
      }

      var GluedInSDKObject = window.GluedIn;
      var activityTimelineModuleObj =
        new GluedInSDKObject.GluedInActivityTimeline();
      let assetId = $(this).closest("div").find("input:eq(1)").val();
      let userPostedComment =
        await activityTimelineModuleObj.activityTimelineAddComment({
          assetId: assetId,
          description: userComment,
        });
      if (userPostedComment.status == 200) {
        let username = "";
        try {
          username = JSON.parse(localStorage.getItem("userData")).fullName;
        } catch (e) {}
        let commentInfo =
          '<div class="comment-box mt-t-15"><ul><li class="img-li"><div class="img-holder"><img src="assets/images/mini-pro.png"></div></li><li class="content-li"><h6 class=" text">' +
          username +
          '</h6><span class="text-blk">' +
          userComment +
          '</span>  </li></ul><a href="" class="comment-dots"><img src="assets/images/hor-dot.svg"></a></div>';
        let commentCount =
          parseInt(
            $(this)
              .closest(".post-slider-box-parent")
              .find(".post-slider-box-bottom-ul")
              .find(".comment-count")
              .html()
          ) + 1;

        $(this)
          .closest(".post-slider-box-parent")
          .find(".post-slider-box-bottom-ul")
          .find(".comment-count")
          .html(commentCount);
        $(commentInfo).insertBefore(
          $(this).closest(
            ".post-slider-box-parent .comment-box-parent .creat-comment-strip"
          )
        );
        $(this).closest("div").find("input:eq(0)").val("");
      } else {
        if (userPostedComment.status == 401) {
          localStorage.clear();
          sessionStorage.clear();
          window.location.href = "https://gluedin.io/web-app//sign-in.html";
        } else {
        }
      }
    });

    $(document).on("click", ".like-video", async function () {
      let accessToken = GluedInSDKAuthObj.getAccessToken();
      if (
        accessToken == "" ||
        accessToken == undefined ||
        accessToken == null
      ) {
        $("#signupmodel").modal("show");
        return;
      }
      var GluedInSDKObject = window.GluedIn;
      var activityTimelineModuleObj =
        new GluedInSDKObject.GluedInActivityTimeline();
      let assetId = $(this).attr("data-videoId");
      if ($(this).hasClass("active likedByUser")) {
        let userPostedComment =
          await activityTimelineModuleObj.activityTimelineUnLike({
            assetId: assetId,
          });
        if (userPostedComment.status == 200) {
          let likeCount = parseInt($(this).find(".like-count").html()) - 1;
          likeCount = likeCount >= 0 ? likeCount : 0;
          $(this).find(".like-count").html(likeCount);
          $(this).removeClass("active likedByUser");
        } else {
          if (userPostedComment.status == 401) {
            localStorage.clear();
            sessionStorage.clear();
            window.location.href = "https://gluedin.io/web-app//sign-in.html";
          } else {
          }
        }
      } else {
        let userPostedComment =
          await activityTimelineModuleObj.activityTimelineLike({
            assetId: assetId,
          });
        if (userPostedComment.status == 200) {
          let likeCount = parseInt($(this).find(".like-count").html()) + 1;
          $(this).find(".like-count").html(likeCount);
          $(this).addClass("active likedByUser");
        } else {
          if (userPostedComment.status == 401) {
            localStorage.clear();
            sessionStorage.clear();
            window.location.href = "https://gluedin.io/web-app//sign-in.html";
          } else {
          }
        }
      }
    });

    $(document).on("click", ".next-video", async function () {
      if (currentIndex != allVideoList.length - 1) {
        currentIndex = currentIndex + 1;
        let videoDetails = allVideoList[currentIndex];
        let contentType = localStorage.getItem("contentType");
        if (contentType == "discover") {
          videoDetails = videoDetails.video;
        }
        bindFeedVideoHtml(videoDetails);
        if (currentIndex == allVideoList.length - 1 && currentIndex != 0) {
          $(".previous-video").show();
          $(".next-video").hide();
        } else if (currentIndex == 0) {
          $(".previous-video").hide();
          if (currentIndex != allVideoList.length - 1) {
            $(".next-video").show();
          }
        } else {
          $(".previous-video").show();
          $(".next-video").show();
        }
      }
    });

    $(document).on("click", ".previous-video", async function () {
      if (currentIndex != 0) {
        currentIndex = currentIndex - 1;
        let videoDetails = allVideoList[currentIndex];
        let contentType = localStorage.getItem("contentType");
        if (contentType == "discover") {
          videoDetails = videoDetails.video;
        }
        bindFeedVideoHtml(videoDetails);
        if (currentIndex == allVideoList.length - 1 && currentIndex != 0) {
          $(".previous-video").show();
          $(".next-video").hide();
        } else if (currentIndex == 0) {
          $(".previous-video").hide();
          if (currentIndex != allVideoList.length - 1) {
            $(".next-video").show();
          }
        } else {
          $(".previous-video").show();
          $(".next-video").show();
        }
      }
    });
    $(document).on("click", ".view-previous-comment", async function () {
      var activityTimelineModuleObj = new GluedIn.GluedInActivityTimeline();
      let limitComment = $(this).attr("data-comment-count");
      let assetId = $(this).attr("data-assetId");
      let feedModuleComment =
        await activityTimelineModuleObj.getActivityTimelineCommentList({
          limit: parseInt(limitComment),
          offset: 5,
          topicId: assetId,
        });
      let commentHtml = await getCommentHtml(feedModuleComment);
    });

    $(document).on("click", ".show-more-content", function () {
      var obj = $(this).closest(".top-details");
      $(this).hide();
      $(obj).find(".show-more-content-section").show();
      $(obj).find(".show-less-content").show();
    });

    $(document).on("click", ".show-less-content", function () {
      var obj = $(this).closest(".top-details");
      $(this).hide();
      $(obj).find(".show-more-content-section").hide();
      $(obj).find(".show-more-content").show();
    });
  });
})(jQuery);
