(function ($) {
  "use strict";
  var GluedInSDKObject = window.GluedIn;
  var GluedInSDKInitilizeObj = new GluedInSDKObject.GluedInSDKInitilize();
  var GluedInSDKAuthObj = new GluedInSDKObject.GluedInAuthModule();
  var limit = 10;
  var offset = 1;
  var totalPages = 0;
  var pageNo = 1;
  var reportReasonContent = { comment: [], user: [], video: [] };
  $(document).ready(function () {
    $(".screen-loader").show();

    $(window).scroll(function () {
      if (
        $(window).scrollTop() >=
        $(document).height() - $(window).height() - 50
      ) {
        if (totalPages > pageNo) {
          pageNo = offset + 1;
          offset = pageNo;
          getFeedList();
        }
      }
    });

    window.getTopProfile = async function () {
      var userModuleObj = new GluedIn.GluedInUserModule();
      var userModuleResponse = await userModuleObj.getTopProfiles({});
      $(".screen-loader").hide();
      if (userModuleResponse.status == 200) {
        let topProfileHtml = "";
        let windowWidth = window.screen.width;
        let profileCharacter = windowWidth > 501 ? 7 : 5;
        userModuleResponse.data.data.forEach(function (profileInfo) {
          let fullName =
            profileInfo.fullName.length > profileCharacter
              ? profileInfo.fullName.substr(0, profileCharacter) + ".."
              : profileInfo.fullName;
          topProfileHtml +=
            '<li class="item"><a href="profile-details/' +
            profileInfo.userId +
            '"><img src="' +
            profileInfo.profileImageUrl +
            '"><span class="sml-text">' +
            fullName +
            "</span></a></li>";
        });

        $(".top-profile-list").html(topProfileHtml);
        $(".profile-box-slider").owlCarousel({
          loop: true,
          items: 6,
          autoplay: true,
          autoplayTimeout: 5000,
          video: true,
          autoHeight: false,
          autoplaySpeed: 1000,
          margin: 0,
          autoplayHoverPause: true,
          nav: false,
          dots: false,
          margin: 25,
          responsive: {
            0: {
              items: 5,
              nav: false,
            },
            600: {
              items: 6,
              nav: false,
            },
            1000: {
              items: 6,
              nav: false,
              loop: false,
            },
          },
        });
      } else {
        if (userModuleResponse.status == 401) {
          window.location.href = "https://gluedin.io/web-app//sign-in.html";
        }
      }
    };

    window.getFeedList = async function () {
      /*Initilize Feed Method*/
      var feedModuleObj = new GluedIn.GluedInFeedModule();
      /*Initilize Activity Method*/
      var activityTimelineModuleObj = new GluedIn.GluedInActivityTimeline();
      /*Get Feed List Method*/
      var feedModuleResponse = await feedModuleObj.getFeedList({
        limit: limit,
        offset: offset,
        c_type: "video",
      });
      $(".screen-loader").hide();

      let accessToken = GluedInSDKAuthObj.getAccessToken();

      if (feedModuleResponse.status == 200) {
        totalPages = Math.ceil(feedModuleResponse.data.total / limit);
        let videoIds = feedModuleResponse.data.data.map((item) => item.videoId);
        let videoLikedByUser = [];
        $(".feed-loader").show();
        if (videoIds.length > 0) {
          if (accessToken) {
            let likeVideos = await feedModuleObj.Like(videoIds);
            if (likeVideos.status == 200 || likeVideos.status == 201)
              videoLikedByUser = likeVideos.data.data;
          }
        }
        $(document).on("click", ".dot-options", function (ele) {
          let accessToken = GluedInSDKAuthObj.getAccessToken();
          if (
            accessToken == "" ||
            accessToken == undefined ||
            accessToken == null
          ) {
            $("#signupmodel").modal("show");
            return;
          }
          const id = $(ele.target).prop("id");
          const type = $(ele.target).attr("data-action");
          const userId = $(ele.target).attr("data-userId");
          const postId = $(ele.target).attr("data-post-id");
          const currentPost = {
            id: id,
            type: type,
            userId: userId,
            postId: postId,
          };
          if (currentPost) {
            localStorage.setItem("currentPost", JSON.stringify(currentPost));
          }
          // vertical and horizontal dots report feeds
          if (ele.target.classList.contains("dot-options")) {
            const dotSubOptions = ele.target.parentElement.nextElementSibling;
            if ($(dotSubOptions).css("display").toLowerCase() == "none") {
              $(dotSubOptions).css("display", "flex");
            } else {
              $(dotSubOptions).css("display", "none");
            }
          }
        });

        feedModuleResponse.data.data.forEach(async function (contentInfo) {
          let contentInfoDetails = contentInfo;
          // report post and comment
          window.reportPostComment = async function (e) {
            e.preventDefault();
            const feedModuleObj = new GluedIn.GluedInFeedModule();
            let reason = "";
            reason = $("input[name=report_option]:checked").val();
            const currentPost = JSON.parse(localStorage.getItem("currentPost"));
            const currentUserInfo = JSON.parse(
              localStorage.getItem("userData")
            );
            const currentUserId = currentUserInfo.userId;
            const postId =
              currentPost.type == "comment" ? currentPost.postId : "";
            const reportPost = {
              userId: currentPost.userId,
              actingUserId: currentUserId,
              assetId: currentPost.id,
              reason: reason,
              event: "report",
              type: currentPost.type,
              postId: postId,
            };

            const feedModuleResponse = await feedModuleObj.Report(reportPost);
            if (feedModuleResponse.status === 201) {
              if (
                feedModuleResponse.data.statusCode === 201 &&
                feedModuleResponse.data.success
              ) {
                $("#report-modal").modal("hide");
              }
            }
          };

          let feedHtml = "";
          let previousCommentCountHtml = "";
          let feedModuleComment =
            await activityTimelineModuleObj.getActivityTimelineCommentList({
              limit: 5,
              offset: 1,
              topicId: contentInfo.videoId,
            });
          if (feedModuleComment.data.total > 5) {
            let commentCount = contentInfoDetails.commentCount - 5;
            previousCommentCountHtml =
              '<div class="text ft-500 view-previous-comment" data-comment-count="' +
              commentCount +
              '" data-assetId="' +
              contentInfo.videoId +
              '"><span class="comment-count" data-comment-count="' +
              commentCount +
              '" data-assetId="' +
              contentInfo.videoId +
              '">' +
              commentCount +
              "</span> View  previous comments</div>";
          }
          let commentHtml = await getCommentHtml(
            feedModuleComment.data,
            contentInfo.videoId
          );

          let likeByuser =
            videoLikedByUser.indexOf(contentInfo.videoId) > -1
              ? "active likedByUser"
              : "";
          let contentDescription = contentInfoDetails.description;
          if (contentDescription.length > 100) {
            contentDescription =
              contentDescription.substr(0, 100) +
              '<a href="javascript:void(0)" class="text-b show-more-content">Show More</a>' +
              ' <span class="show-more-content-section" style="display:none;">' +
              contentDescription.substr(100, contentDescription.length) +
              '</span> <a href="javascript:void(0)" class="text-b show-less-content" style="display:none;">Show Less</a>';
          }
          var websiteUrl = encodeURI("https://gluedin.io/web-app//");
          if (contentInfoDetails.contentType == "image") {
            let slideImages = "";
            contentInfoDetails.contentUrls.forEach(function (imageContent) {
              slideImages +=
                '<div class="item"><img src="' +
                imageContent.urls +
                '" class="full"></div>';
            });
            let showFollowButton = "block";
            let followingList = localStorage.getItem("following");
            if (
              followingList != undefined &&
              followingList != null &&
              followingList != "undefined"
            ) {
              followingList = JSON.parse(followingList);
              if (followingList.includes(contentInfoDetails.user.userId)) {
                showFollowButton = "none";
              }
            }
            let profilePictureUrl = "assets/images/mini-pro.png";
            if (contentInfoDetails.user.profileImageUrl) {
              profilePictureUrl = contentInfoDetails.user.profileImageUrl;
            }
            var usedHashTagTitle = Array.isArray(
              contentInfoDetails.hashtagTitles
            )
              ? contentInfoDetails.hashtagTitles.join(",")
              : "";
            feedHtml +=
              '<div class="full-post-box ordering"><div class="post-box-parent col-md-7 first_div">  <div class="post-slider-box-parent"><div class="post-slider-box owl-carousel owl-theme">' +
              slideImages +
              '</div><div class="post-slider-box-bottom"><div class="strip">  <ul class="post-slider-box-bottom-ul">  <li><a href="javascript:void(0);" class="like-video ' +
              likeByuser +
              '" data-videoId="' +
              contentInfoDetails.videoId +
              '"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 33.899 30.435"><path id="Heart" d="M129.908,216.734a8.443,8.443,0,0,0-6.28-2.734,7.9,7.9,0,0,0-4.934,1.7,10.08,10.08,0,0,0-1.995,2.083A10.091,10.091,0,0,0,114.7,215.7a7.9,7.9,0,0,0-4.933-1.7,8.444,8.444,0,0,0-6.281,2.734,9.814,9.814,0,0,0-2.491,6.7,11.687,11.687,0,0,0,3.114,7.65,66.4,66.4,0,0,0,7.8,7.317c1.08.92,2.3,1.964,3.576,3.076a1.843,1.843,0,0,0,2.427,0c1.271-1.111,2.5-2.156,3.577-3.077a66.366,66.366,0,0,0,7.8-7.316,11.686,11.686,0,0,0,3.114-7.65,9.814,9.814,0,0,0-2.491-6.7Zm0,0" transform="translate(-99.75 -212.75)" fill="none" stroke="#777" stroke-width="2.5"/></svg><span class="like-count">' +
              contentInfoDetails.likeCount +
              '</span></a></li>  <li><a href="javascript:void(0);"><img src="assets/images/comment.svg"><span class="comment-count">' +
              contentInfoDetails.commentCount +
              '</span></a></li>  <li><a href="javascript:void(0);" class="social-share-options"><img src="assets/images/share.svg"></a><ul class="social-share"><li><a href="https://www.facebook.com/sharer.php?u=' +
              websiteUrl +
              '" target="blank" rel="noopener noreferrer"><i class=""fa fa-facebook" alt="Share Page on Facebook" /></i></a></li><li><a href="https://twitter.com/intent/tweet?url=' +
              websiteUrl +
              "&text=" +
              contentInfoDetails.description +
              "&hashtags=" +
              usedHashTagTitle +
              '" target="blank" rel="noopener noreferrer"><i class="fa fa-twitter" alt="Share Page on Twitter" /></i></a></li><li><a href="https://www.linkedin.com/sharing/share-offsite/?url=' +
              websiteUrl +
              '" target="blank" rel="noopener noreferrer"><i class="fa fa-linkedin" alt="Share Page on LinkedIn" /></i></a></li></ul></li> <li class="feed-options float-r"><a href="javascript:void(0);" class="vert-dots"><img src="assets/images/blue-dot.svg" class="dot-options" id="' +
              contentInfoDetails.videoId +
              '" data-userId="' +
              contentInfoDetails.userId +
              '" data-action="video"/></a><ul class="dot-suboption"><li><a href="javascript:void(0);" class="report-button" data-action="video"><span><i class="fa fa-exclamation-circle" aria-hidden="true"></i></span>Report Comment</a></li></ul></li> </ul>  <!-- <a href="" class="dot-icon"><img src="assets/images/blue-dot.svg"></a> -->  </div>  <div class="comment-box-parent">  ' +
              previousCommentCountHtml +
              "  " +
              commentHtml +
              '  <div class="creat-comment-strip">  <div class="creat-comment-box">  <input type="text" name="post_comment" placeholder="Write a comment"> <input type="hidden" name="assestId" placeholder="assestId" value="' +
              contentInfoDetails.videoId +
              '">   <a href="javascript:void(0);" class="comment-submit">  <img src="assets/images/send-icon.svg">  </a>  </div>  </div>  </div></div></div></div><div class="col-md-5 post-detail-box-parent second_div"><div class="post-detail-box"><div class="top-details"><ul><li class="img-li"><div class="img-holder"><a href="profile-details/' +
              contentInfoDetails.user.userId +
              '"><img src="' +
              profilePictureUrl +
              '"></a></div></li><li><h3 class="ft-500"><a href="profile-details/' +
              contentInfoDetails.user.userId +
              '">' +
              contentInfoDetails.user.fullName +
              '</a></h3></li><li><button class="follow-user ' +
              contentInfoDetails.user.userId +
              '" id="' +
              contentInfoDetails.user.userId +
              '" style="display:' +
              showFollowButton +
              '">Follow</button></li></ul><div class="c-text">' +
              contentInfoDetails.title +
              '</div><div class="sml-text mt-t-5">' +
              contentDescription +
              "</div></div><hr/>";
            if (contentInfoDetails.shoppable) {
              if (contentInfoDetails.products) {
                feedHtml +=
                  '<div class="bottom-deatails"><div class="text">Shop</div><ul class="bottom-deatails-ul">';
                contentInfoDetails.products.forEach(function (productInfo) {
                  let shoppableUrl =
                    productInfo.shoppableLink.indexOf("http://") < 0 &&
                    productInfo.shoppableLink.indexOf("https://") < 0
                      ? "http://" + productInfo.shoppableLink
                      : productInfo.shoppableLink;
                  feedHtml +=
                    '<li><div class="box"><div class="img-box"><img src="' +
                    productInfo.imageUrl +
                    '"></div><span cl>' +
                    productInfo.productName +
                    "</span><span cl>$" +
                    productInfo.mrp +
                    '</span><a href="' +
                    shoppableUrl +
                    '" target="_blank" class="text-b">Shop Now</a></div></li>';
                });
                feedHtml += "</ul></div>";
              }
            }
            feedHtml += "</div></div> </div>";
          } else {
            let showFollowButton = "block";
            let followingList = localStorage.getItem("following");
            if (
              followingList != undefined &&
              followingList != null &&
              followingList != "undefined"
            ) {
              followingList = JSON.parse(followingList);
              if (followingList.includes(contentInfoDetails.user.userId)) {
                showFollowButton = "none";
              }
            }
            let profilePictureUrl = "assets/images/mini-pro.png";
            if (contentInfoDetails.user.profileImageUrl) {
              profilePictureUrl = contentInfoDetails.user.profileImageUrl;
            }
            var usedHashTagTitle = Array.isArray(
              contentInfoDetails.hashtagTitles
            )
              ? contentInfoDetails.hashtagTitles.join(",")
              : "";
            feedHtml +=
              '<div class="full-post-box ordering"><div class="post-box-parent col-md-7 first_div">  <div class="post-slider-box-parent"><div class="post-slider-box-02 video video-player" style="background: #000;"><video class="video_00" width="100%"  playsinline poster="' +
              contentInfoDetails.thumbnailUrl +
              '"><source src="' +
              contentInfoDetails.s3Url +
              '" type="video/mp4">Your browser does not support the video tag.</video><div class="player-controls"><button class="play-button" title="Play"><i class="fa fa-play" aria-hidden="true"></i></button><a class="unmute-button" title="Mute"><i class="fa fa-volume-up" aria-hidden="true"></i></a><a class="mute-button" title="Unmute"><i class="fa fa-volume-off" aria-hidden="true"></i></a></div></div><div class="post-slider-box-bottom"><div class="strip">  <ul class="post-slider-box-bottom-ul">  <li><a href="javascript:void(0);" class="like-video ' +
              likeByuser +
              '" data-videoId="' +
              contentInfoDetails.videoId +
              '"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 33.899 30.435"><path id="Heart" d="M129.908,216.734a8.443,8.443,0,0,0-6.28-2.734,7.9,7.9,0,0,0-4.934,1.7,10.08,10.08,0,0,0-1.995,2.083A10.091,10.091,0,0,0,114.7,215.7a7.9,7.9,0,0,0-4.933-1.7,8.444,8.444,0,0,0-6.281,2.734,9.814,9.814,0,0,0-2.491,6.7,11.687,11.687,0,0,0,3.114,7.65,66.4,66.4,0,0,0,7.8,7.317c1.08.92,2.3,1.964,3.576,3.076a1.843,1.843,0,0,0,2.427,0c1.271-1.111,2.5-2.156,3.577-3.077a66.366,66.366,0,0,0,7.8-7.316,11.686,11.686,0,0,0,3.114-7.65,9.814,9.814,0,0,0-2.491-6.7Zm0,0" transform="translate(-99.75 -212.75)" fill="none" stroke="#777" stroke-width="2.5"/></svg><span class="like-count">' +
              contentInfoDetails.likeCount +
              '</span></a></li>  <li><a href="javascript:void(0);"><img src="assets/images/comment.svg"><span class="comment-count">' +
              contentInfoDetails.commentCount +
              '</span></a></li>  <li><a href="javascript:void(0);" class="social-share-options"><img src="assets/images/share.svg"></a><ul class="social-share"><li><a href="https://www.facebook.com/sharer.php?u=' +
              websiteUrl +
              '" target="blank" rel="noopener noreferrer"><i class="fa fa-facebook" alt="Share Page on Facebook" /></i></a></li><li><a href="https://twitter.com/intent/tweet?url=' +
              websiteUrl +
              "&text=" +
              contentInfoDetails.description +
              "&hashtags=" +
              usedHashTagTitle +
              '" target="blank" rel="noopener noreferrer"><i class="fa fa-twitter" alt="Share Page on Twitter" /></i></a></li><li><a href="https://www.linkedin.com/sharing/share-offsite/?url=' +
              websiteUrl +
              '" target="blank" rel="noopener noreferrer"><i class="fa fa-linkedin" alt="Share Page on LinkedIn" /></i></a></li></ul></li><li class="feed-options float-r"><a href="javascript:void(0);" class="vert-dots"><img src="assets/images/blue-dot.svg" class="dot-options" id="' +
              contentInfoDetails.videoId +
              '" data-userId="' +
              contentInfoDetails.userId +
              '" data-action="video"/></a><ul class="dot-suboption"><li><a href="javascript:void(0);" class="report-button" data-action="video"><span><i class="fa fa-exclamation-circle" aria-hidden="true"></i></span>Report Post</a></li></ul></li>  </ul>  <a href="" class="dot-icon"><img src="assets/images/blue-dot.svg"></a>  </div>  <div class="comment-box-parent">  ' +
              previousCommentCountHtml +
              "  " +
              commentHtml +
              '  <div class="creat-comment-strip">  <div class="creat-comment-box">  <input type="text" name="post_comment" placeholder="Write a comment"> <input type="hidden" name="assestId" placeholder="assestId" value="' +
              contentInfoDetails.videoId +
              '">  <a href="javascript:void(0);" class="comment-submit">  <img src="assets/images/send-icon.svg">  </a>  </div>  </div>  </div></div></div></div><div class="col-md-5 post-detail-box-parent second_div"><div class="post-detail-box"><div class="top-details"><ul><li class="img-li"><div class="img-holder"><a href="profile-details/' +
              contentInfoDetails.user.userId +
              '"><img src="' +
              profilePictureUrl +
              '"></a></div></li><li><h3 class="ft-500"><a href="profile-details/' +
              contentInfoDetails.user.userId +
              '">' +
              contentInfoDetails.user.fullName +
              '</a></h3></li><li><button class="follow-user" id="' +
              contentInfoDetails.user.userId +
              '" style="display:' +
              showFollowButton +
              '">Follow</button></li></ul><div class="c-text">' +
              contentInfoDetails.title +
              '</div><div class="sml-text mt-t-5">' +
              contentDescription +
              "</div></div><hr/>";
            if (contentInfoDetails.shoppable) {
              if (contentInfoDetails.products) {
                feedHtml +=
                  '<div class="bottom-deatails"><div class="text">Shop</div><ul class="bottom-deatails-ul">';
                contentInfoDetails.products.forEach(function (productInfo) {
                  let shoppableUrl =
                    productInfo.shoppableLink.indexOf("http://") < 0 &&
                    productInfo.shoppableLink.indexOf("https://") < 0
                      ? "http://" + productInfo.shoppableLink
                      : productInfo.shoppableLink;
                  feedHtml +=
                    '<li><div class="box"><div class="img-box"><img src="' +
                    productInfo.imageUrl +
                    '"></div><span cl>' +
                    productInfo.productName +
                    "</span><span cl>$" +
                    productInfo.mrp +
                    '</span><a href="' +
                    shoppableUrl +
                    '" class="text-b">Shop Now</a></div></li>';
                });
                feedHtml += "</ul></div>";
              }
            }
            feedHtml += "</div></div> </div>";
          }
          $(".profile-content-list").append(feedHtml);
          $(".feed-loader").hide();
          autoPlayVideo();

          /*const videoPlayer = document.querySelector('.video-player');
const video = videoPlayer.querySelector('.video_00')
const playButton = videoPlayer.querySelector('.play-button')*/
          // const volume = videoPlayer.querySelector('.volume')
          // const currentTimeElement = videoPlayer.querySelector('.current')
          // const durationTimeElement = videoPlayer.querySelector('.duration')
          // const progress = videoPlayer.querySelector('.video-progress')
          // const progressBar = videoPlayer.querySelector('.video-progress-filled')

          //Play and Pause button
          /*playButton.addEventListener('click', (e) => {
  if(video.paused){
    video.play()
    e.target.textContent = ''
  } else {
    video.pause()
    e.target.textContent = '►'
  }
})*/

          //volume
          // volume.addEventListener('mousemove', (e)=> {
          //   video.volume = e.target.value
          // })

          //current time and duration
          /*const currentTime = () => {
  let currentMinutes = Math.floor(video.currentTime / 60)
  let currentSeconds = Math.floor(video.currentTime - currentMinutes * 60)
  let durationMinutes = Math.floor(video.duration / 60)
  let durationSeconds = Math.floor(video.duration - durationMinutes * 60)

  currentTimeElement.innerHTML = `${currentMinutes}:${currentSeconds < 10 ? '0'+currentSeconds : currentSeconds}`
  durationTimeElement.innerHTML = `${durationMinutes}:${durationSeconds}`
}

video.addEventListener('timeupdate', currentTime)*/

          //Progress bar
          // video.addEventListener('timeupdate', () =>{
          //   const percentage = (video.currentTime / video.duration) * 100
          //   progressBar.style.width = `${percentage}%`
          // })

          //change progress bar on click
          // progress.addEventListener('click', (e) =>{
          //   const progressTime = (e.offsetX / progress.offsetWidth) * video.duration
          //   video.currentTime = progressTime
          // })

          $(".post-slider-box").owlCarousel({
            loop: true,
            items: 1,
            autoplay: true,
            autoplayTimeout: 5000,
            video: true,
            autoHeight: false,
            autoplaySpeed: 1000,
            margin: 0,
            singleItem: true,
            autoplayHoverPause: true,
            nav: false,
            dots: true,
            navText: [
              '<img src="assets/images/svg">',
              '<img src="assets/images/right-arrow.svg">',
            ],
          });
        });
      } else {
        if (feedModuleResponse.status == 401) {
          window.location.href = "https://gluedin.io/web-app//sign-in.html";
        }
      }
    };

    window.getReportReason = async function () {
      const feedModuleObj = new GluedIn.GluedInFeedModule();
      const reportReasonResponse = await feedModuleObj.ReportReason();
      if (reportReasonResponse.status == 200 || reportReasonResponse == 201) {
        reportReasonContent = reportReasonResponse.data.data;
      }
    };

    getTopProfile();
    getFeedList();
    getReportReason();

    function getCommentHtml(commentData, assetId) {
      let commentHtmlList = "";
      if (commentData.data.length > 0) {
        for (let c of commentData.data) {
          commentHtmlList +=
            '<div class="comment-box mt-t-15"><ul><li class="img-li"><div class="img-holder"><a href="https://gluedin.io/web-app//profile-details/' +
            c.userId +
            '"><img src="' +
            c.profileImageUrl +
            '"></a></div></li><li class="content-li"><a href="https://gluedin.io/web-app//profile-details/' +
            c.userId +
            '"><h6 class=" text">' +
            c.fullName +
            '</h6></a><span class="text-blk">' +
            c.description +
            '</span><a href="" class=" text-g rply-more">View ' +
            c.replyCount +
            ' replies</a>  </li></ul><a href="javascript:void(0);" class="comment-dots"><img src="assets/images/hor-dot.svg" class="dot-options" data-post-id="' +
            c.postId +
            '" data-userId="' +
            c.userId +
            '" data-action="comment" id="' +
            assetId +
            '"><ul class="dot-suboption"><li><a href="javascript:void(0);" class="report-button" data-action="comment" ><span><i class="fa fa-exclamation-circle" aria-hidden="true"></i></span>Report Comment</a></li></ul></a></div>';
        }
      }
      return commentHtmlList;
    }

    $(document).on("click", ".comment-submit", async function () {
      let userComment = $(this).closest("div").find("input:eq(0)").val();
      if (!userComment) return;

      let accessToken = GluedInSDKAuthObj.getAccessToken();
      if (
        accessToken == "" ||
        accessToken == undefined ||
        accessToken == null
      ) {
        $("#signupmodel").modal("show");
        return;
      }

      var GluedInSDKObject = window.GluedIn;
      var activityTimelineModuleObj =
        new GluedInSDKObject.GluedInActivityTimeline();
      let assetId = $(this).closest("div").find("input:eq(1)").val();
      let userPostedComment =
        await activityTimelineModuleObj.activityTimelineAddComment({
          assetId: assetId,
          description: userComment,
          postId: "",
        });
      if (userPostedComment.status == 200) {
        let username = "";
        let profileImageUrl = "assets/images/mini-pro.png";
        let profileId = "";
        try {
          username = JSON.parse(localStorage.getItem("userData")).fullName;
          profileImageUrl = JSON.parse(
            localStorage.getItem("userData")
          ).profileImageUrl;
          profileId = JSON.parse(localStorage.getItem("userData")).userId;
        } catch (e) {}
        let commentInfo =
          '<div class="comment-box mt-t-15"><ul><li class="img-li"><div class="img-holder"><a href="https://gluedin.io/web-app//profile-details/' +
          profileId +
          '"><img src="' +
          profileImageUrl +
          '"></a></div></li><li class="content-li"><h6 class=" text">' +
          username +
          '</h6><span class="text-blk">' +
          userComment +
          '</span> </li></ul><a href="javascript:void(0);" class="comment-dots"><img src="assets/images/hor-dot.svg" class="dot-options"><ul class="dot-suboption"><li><a href="javascript:void(0);" class="report-button" data-action="comment"><span><i class="fa fa-exclamation-circle" aria-hidden="true"></i></span>Report Comment</a></li></ul></a></div>';
        let commentCount =
          parseInt(
            $(this)
              .closest(".post-slider-box-parent")
              .find(".post-slider-box-bottom-ul")
              .find(".comment-count")
              .html()
          ) + 1;

        $(this)
          .closest(".post-slider-box-parent")
          .find(".post-slider-box-bottom-ul")
          .find(".comment-count")
          .html(commentCount);
        $(commentInfo).insertBefore(
          $(this).closest(
            ".post-slider-box-parent .comment-box-parent .creat-comment-strip"
          )
        );
        $(this).closest("div").find("input:eq(0)").val("");
      } else {
        if (userPostedComment.status == 401) {
          window.location.href = "https://gluedin.io/web-app//sign-in.html";
        } else {
        }
      }
    });

    /*Play Video Button*/
    $(document).on("click", ".play-button", function (e) {
      e.preventDefault();
      $(".play-button").removeClass("active");
      $(this).addClass("active");
      $(".play-button").each(function () {
        if (!$(this).hasClass("active")) {
          let videoPlayer = $(this).closest(".video-player");
          let video = $(videoPlayer).find(".video_00").get(0);
          video.pause();
          this.innerHTML = '<i class="fa fa-play" aria-hidden="true"></i>';
          $(this).closest(".player-controls").find("a").hide();
        }
      });
      var videoPlayer = $(this).closest(".video-player");
      var video = $(videoPlayer).find(".video_00").get(0);
      console.log(video.paused);
      if (video.paused) {
        video.play();
        this.textContent = "";
        $(this).closest(".player-controls").find(".unmute-button").show();
      } else {
        video.pause();
        $(this).closest(".player-controls").find("a").hide();
        this.innerHTML = '<i class="fa fa-play" aria-hidden="true"></i>';
      }
    });

    /*Mute Video*/

    $(document).on("click", ".unmute-button", function (e) {
      e.preventDefault();

      var videoPlayer = $(this).closest(".video-player");
      var video = $(videoPlayer).find(".video_00").get(0);
      video.muted = true;
      $(this).closest(".player-controls").find(".mute-button").show();
      $(this).hide();
    });
    $(document).on("click", ".mute-button", function (e) {
      e.preventDefault();

      var videoPlayer = $(this).closest(".video-player");
      var video = $(videoPlayer).find(".video_00").get(0);
      video.muted = false;
      $(this).closest(".player-controls").find(".unmute-button").show();
      $(this).hide();
    });
    $(document).on("click", ".like-video", async function () {
      let accessToken = GluedInSDKAuthObj.getAccessToken();
      if (
        accessToken == "" ||
        accessToken == undefined ||
        accessToken == null
      ) {
        $("#signupmodel").modal("show");
        return;
      }
      var GluedInSDKObject = window.GluedIn;
      var activityTimelineModuleObj =
        new GluedInSDKObject.GluedInActivityTimeline();
      let assetId = $(this).attr("data-videoId");
      if ($(this).hasClass("active likedByUser")) {
        let userPostedComment =
          await activityTimelineModuleObj.activityTimelineUnLike({
            assetId: assetId,
          });
        if (userPostedComment.status == 200) {
          let likeCount = parseInt($(this).find(".like-count").html()) - 1;
          likeCount = likeCount >= 0 ? likeCount : 0;
          $(this).find(".like-count").html(likeCount);
          $(this).removeClass("active likedByUser");
        } else {
          if (userPostedComment.status == 401) {
            window.location.href = "https://gluedin.io/web-app//sign-in.html";
          } else {
          }
        }
      } else {
        let userPostedComment =
          await activityTimelineModuleObj.activityTimelineLike({
            assetId: assetId,
          });
        if (userPostedComment.status == 200) {
          let likeCount = parseInt($(this).find(".like-count").html()) + 1;
          $(this).find(".like-count").html(likeCount);
          $(this).addClass("active likedByUser");
        } else {
          if (userPostedComment.status == 401) {
            window.location.href = "https://gluedin.io/web-app//sign-in.html";
          } else {
          }
        }
      }
    });

    // report modal
    $(document).on("click", ".report-button", function () {
      var actionType = $(this).attr("data-action");
      var reportReasonInfo = reportReasonContent[actionType];
      var reasonHtml = "";
      reportReasonInfo.forEach(function (value) {
        reasonHtml +=
          '<div class="radio-inputfield"><label for="' +
          value.replace(" ", "_") +
          '">' +
          value +
          '</label><input  type="radio"  id="' +
          value.replace(" ", "_") +
          '"  name="report_option"  value="' +
          value +
          '"/><br /></div>';
      });
      if (reasonHtml != "") $("#report-post-comment-content").html(reasonHtml);
      $("#report-modal").modal("show");
      $(".dot-suboption").css("display", "none");
    });

    // cancel button
    $(document).on("click", ".cancel-btn", function () {
      $(".dot-suboption").css("display", "none");
      $(".dot-suboption").css("display", "none");
      $("#report-modal").modal("hide");
    });
    // except dot click dropdown needs to be closed
    $(document).on("click", function (ele) {
      if (!ele.target.classList.contains("dot-options")) {
        $(".dot-suboption").css("display", "none");
      }
    });

    // follow user
    $(document).on("click", ".follow-user", async function (ele) {
      let accessToken = GluedInSDKAuthObj.getAccessToken();
      if (
        accessToken == "" ||
        accessToken == undefined ||
        accessToken == null
      ) {
        $("#signupmodel").modal("show");
        return;
      }
      const userId = $(ele.target).prop("id");
      var userModuleObj = new GluedIn.GluedInUserModule();
      var formData = {
        followingId: userId,
        isFollow: true,
      };
      var userModuleResponse = await userModuleObj.followUser(formData);
      if (
        userModuleResponse.status === 201 ||
        userModuleResponse.status === 200
      ) {
        let followingList = localStorage.getItem("following");
        if (
          followingList != undefined &&
          followingList != null &&
          followingList != "undefined"
        ) {
          followingList = JSON.parse(followingList);
          followingList.push(userId);
          localStorage.setItem("following", JSON.stringify(followingList));
        }
        $(ele.target).css("display", "none");
        $("." + userId).css("display", "none");
      }
    });

    $(document).on("click", ".view-previous-comment", async function () {
      var activityTimelineModuleObj = new GluedIn.GluedInActivityTimeline();
      let limitComment = $(this).attr("data-comment-count");
      limitComment = parseInt(limitComment) + 5;
      let assetId = $(this).attr("data-assetId");
      let feedModuleComment =
        await activityTimelineModuleObj.getActivityTimelineCommentList({
          limit: parseInt(limitComment),
          offset: 1,
          topicId: assetId,
        });
      let commentHtml = await getCommentHtml(feedModuleComment.data, assetId);
      $(this).closest(".comment-box-parent").find(".comment-box").remove();
      $(commentHtml).insertAfter($(this));
      $(this).remove();
    });

    $(document).on("click", ".show-more-content", function () {
      var obj = $(this).closest(".top-details");
      $(this).hide();
      $(obj).find(".show-more-content-section").show();
      $(obj).find(".show-less-content").show();
    });

    $(document).on("click", ".show-less-content", function () {
      var obj = $(this).closest(".top-details");
      $(this).hide();
      $(obj).find(".show-more-content-section").hide();
      $(obj).find(".show-more-content").show();
    });

    /*Social Share Options*/
    $(document).on("click", ".social-share-options", function () {
      $(this).next(".social-share").toggle();
    });

    function myHandler(e) {
      debugger;
    }

    function autoPlayVideo() {
      // the list of our video elements
      var videos = document.querySelectorAll("video");
      // an array to store the top and bottom of each of our elements
      var videoPos = [];
      // a counter to check our elements position when videos are loaded
      var loaded = 0;

      // Here we get the position of every element and store it in an array
      function checkPos() {
        // loop through all our videos
        for (var i = 0; i < videos.length; i++) {
          var element = videos[i];
          element.addEventListener("ended", function () {
            let videoPlayer = $(this).closest(".video-player");
            $(videoPlayer).find(".play-button").html("►");
            $(videoPlayer).find(".unmute-button").hide();
            $(videoPlayer).find(".mute-button").hide();
          });
          // get its bounding rect
          var rect = element.getBoundingClientRect();
          // we may already have scrolled in the page
          // so add the current pageYOffset position too
          var top = rect.top + window.pageYOffset;
          var bottom = rect.bottom + window.pageYOffset;
          // it's not the first call, don't create useless objects
          if (videoPos[i]) {
            videoPos[i].el = element;
            videoPos[i].top = top;
            videoPos[i].bottom = bottom;
          } else {
            // first time, add an event listener to our element
            element.addEventListener("loadeddata", function () {
              if (++loaded === videos.length - 1) {
                // all our video have ben loaded, recheck the positions
                // using rAF here just to make sure elements are rendered on the page
                requestAnimationFrame(checkPos);
              }
            });
            // push the object in our array
            videoPos.push({
              el: element,
              top: top,
              bottom: bottom,
            });
          }
        }
      }
      // an initial check
      checkPos();

      var scrollHandler = function () {
        // our current scroll position

        // the top of our page
        var min = window.pageYOffset;
        // the bottom of our page
        var max = min + window.innerHeight;

        videoPos.forEach(function (vidObj) {
          // the top of our video is visible
          if (vidObj.top >= min && vidObj.top < max) {
            // play the video
            //vidObj.el.play();
          }

          // the bottom of the video is above the top of our page
          // or the top of the video is below the bottom of our page
          // ( === not visible anyhow )
          if (vidObj.bottom <= min || vidObj.top >= max) {
            if (!vidObj.el.paused) {
              let videoPlayer = $(vidObj.el).closest(".video-player");
              $(videoPlayer).find(".play-button").html("►");
            }

            // stop the video
            vidObj.el.pause();
          }
        });
      };
      // add the scrollHandler
      window.addEventListener("scroll", scrollHandler, true);
      // don't forget to update the positions again if we do resize the page
      window.addEventListener("resize", checkPos);
    }
  });
})(jQuery);
