(function ($) {
  "use strict";
  var GluedInSDKObject = window.GluedIn;
  var GluedInSDKInitilizeObj = new GluedInSDKObject.GluedInSDKInitilize();
  var GluedInSDKAuthObj = new GluedInSDKObject.GluedInAuthModule();

  $(document).ready(function () {
    window.initilizeSDKMethod = function () {
      var GluedInSDKObject = window.GluedIn;
      var GluedInSDKInitilizeObj = new GluedInSDKObject.GluedInSDKInitilize();
      var sdkInitilizeData = GluedInSDKInitilizeObj.initialize({
        apiKey: "57c5c0c1-8513-4968-b125-XXXXXXXXX",
        secretKey: "77ccde3e-b0a2-4f4e-aff8-XXXXXXXXß"
      });
    };
    var guestToken = GluedInSDKAuthObj.getGuestToken();
    if (guestToken == "" || guestToken == undefined) {
      initilizeSDKMethod();
    }

    var accessToken = GluedInSDKAuthObj.getAccessToken();
    if (accessToken != "" && accessToken != undefined && accessToken != null) {
      $(".user-sign-out").show();
    }

    window.userSignUp = async function (e) {
      e.preventDefault();
      $(".error-alert").remove();
      $(".success-alert").remove();
      $(".submit-button").addClass("disabled");
      var authLoginInput = new GluedIn.GluedInAuthModule();
      let signupRawData = {
        fullName: $("#fullname").val(),
        email: $("#email").val(),
        password: $("#password").val(),
        termConditionAccepted: true,
      };
      var userSignUpResponse = await authLoginInput.SignupRawData(
        signupRawData
      );
      $(".submit-button").removeClass("disabled");
      if (userSignUpResponse.status == 200) {
        if (userSignUpResponse.data.statusCode == 200) {
          $(
            '<div class="alert alert-success success-alert" role="alert">	' +
              userSignUpResponse.data.message +
              "</div>"
          ).insertBefore(".first-input-box");
          $("#signupForm").trigger("reset");
        } else {
          $(
            '<div class="alert alert-danger error-alert" role="alert">	' +
              userSignUpResponse.data.message +
              "</div>"
          ).insertBefore(".first-input-box");
        }
        //alert(userSignUpResponse.data.message);
      } else {
        $(
          '<div class="alert alert-danger error-alert" role="alert">	' +
            userSignUpResponse.data.message +
            "</div>"
        ).insertBefore(".first-input-box");
        //alert(userSignUpResponse.message);
      }
    };

    window.userLogin = async function (e) {
      e.preventDefault();
      $(".error-alert").remove();
      $(".success-alert").remove();
      $(".submit-button").addClass("disabled");
      var authLoginInput = new window.GluedIn.GluedInAuthModule();
      let signInRawData = {
        email: $("#email").val(),
        password: $("#password").val(),
        deviceId: "23424dsffsf",
        deviceType: "android",
      };
      var userSignIpResponse = await authLoginInput.AuthRawData(signInRawData);
      $(".submit-button").removeClass("disabled");
      if (userSignIpResponse.status == 200) {
        if (userSignIpResponse.data.statusCode == 200) {
          var userModuleObj = new window.GluedIn.GluedInUserModule();

          var userConfigResponse = await userModuleObj.getUserMetaIds();

          if (
            userConfigResponse.status == 200 ||
            userConfigResponse.status == 201
          ) {
            let following = userConfigResponse.data.data.following || [];
            localStorage.setItem("following", JSON.stringify(following));
          }
          /*$(
            '<div class="alert alert-success success-alert" role="alert">	' +
              userSignIpResponse.data.message +
              "</div>"
          ).insertBefore(".first-input-box");*/
          //$("#signInForm").trigger("reset");
          window.location.href = "https://gluedin.io/web-app//home-feed.html";
        } else {
          $(
            '<div class="alert alert-danger error-alert" role="alert">	' +
              userSignIpResponse.data.message +
              "</div>"
          ).insertBefore(".first-input-box");
        }
      } else {
        $(
          '<div class="alert alert-danger error-alert" role="alert">	' +
            userSignIpResponse.data.message +
            "</div>"
        ).insertBefore(".first-input-box");
      }
    };

    window.userForgotPassword = async function (e) {
      e.preventDefault();
      $(".error-alert").remove();
      $(".success-alert").remove();
      $(".submit-button").addClass("disabled");
      var authLoginInput = new GluedIn.GluedInUserModule();
      let email = encodeURI($("#email").val());
      var userSignIpResponse = await authLoginInput.userForgotpassword(email);
      $(".submit-button").removeClass("disabled");
      if (userSignIpResponse.status == 200) {
        if (userSignIpResponse.data.statusCode == 200) {
          $(
            '<div class="alert alert-success success-alert" role="alert">	' +
              userSignIpResponse.data.message +
              "</div>"
          ).insertBefore(".first-input-box");
          $("#signInForm").trigger("reset");
        } else {
          $(
            '<div class="alert alert-danger error-alert" role="alert">	' +
              userSignIpResponse.data.message +
              "</div>"
          ).insertBefore(".first-input-box");
        }
      } else {
        if (userSignIpResponse == 404) {
          $(
            '<div class="alert alert-danger error-alert" role="alert">	User is not registered with us</div>'
          ).insertBefore(".first-input-box");
        } else
          $(
            '<div class="alert alert-danger error-alert" role="alert">	' +
              userSignIpResponse.data.message +
              "</div>"
          ).insertBefore(".first-input-box");
      }
    };

    $(document).on("click", ".go-to-user-profile", function () {
      let accessToken = GluedInSDKAuthObj.getAccessToken();
      if (
        accessToken == "" ||
        accessToken == undefined ||
        accessToken == null
      ) {
        $("#signupmodel").modal("show");
      } else {
        window.location.href = "https://gluedin.io/web-app//profile.html";
      }
    });

    const isCreator = JSON.parse(localStorage.getItem("userData"))?.creator;
    if (isCreator == true) {
      $(".go-to-page-create-content").css("display", "block");
    } else {
      $(".go-to-page-create-content").css("display", "none");
    }

    $(document).on("click", ".go-to-page-create-content", function () {
      let accessToken = GluedInSDKAuthObj.getAccessToken();
      if (
        accessToken == "" ||
        accessToken == undefined ||
        accessToken == null
      ) {
        $("#signupmodel").modal("show");
      } else {
        window.location.href =
          "https://gluedin.io/web-app//creat-page-01.html";
      }
    });

    $(document).on("click", ".go-to-notification", function () {
      let accessToken = GluedInSDKAuthObj.getAccessToken();
      if (
        accessToken == "" ||
        accessToken == undefined ||
        accessToken == null
      ) {
        $("#signupmodel").modal("show");
      } else {
        window.location.href =
          "https://gluedin.io/web-app//notification.html";
      }
    });

    $(document).on("click", ".showHidePassword", function () {
      if ($("#password").attr("type") == "password") {
        $("#password").attr("type", "text");
      } else {
        $("#password").attr("type", "password");
      }
    });
    $(document).on("click", ".user-sign-out", function () {
      localStorage.clear();
      window.location.href = "https://gluedin.io/web-app//sign-in.html";
    });
  });

  /*Google Login Module */
  function HandleGoogleApiLibrary() {
    gapi.load("client:auth2", {
      callback: function () {
        // Initialize client & auth libraries
        gapi.client
          .init({
            apiKey: "AIzaSyDD7mgErTWcj1McOPP_99Vu8ipa9cocgBk",
            clientId:
              "875270431628-rfdtbh85juv9bsmjqagt1jdss88euhfu.apps.googleusercontent.com",
            scope:
              "https://www.googleapis.com/auth/userinfo.profile https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/plus.me",
          })
          .then(
            function (success) {},
            function (error) {}
          );
      },
      onerror: function () {},
    });
  }

  $(".google-login-button").on("click", function () {
    // API call for Google login
    gapi.auth2
      .getAuthInstance()
      .signIn()
      .then(
        async function (success) {
          let basicProfile = success.getBasicProfile();
          let provider_auth_id = basicProfile.getId();
          let email_address = basicProfile.getEmail();
          let first_name = basicProfile.getGivenName();
          let last_name = basicProfile.getFamilyName();
          let picture = basicProfile.getImageUrl();
          let accessToken = success.getAuthResponse().access_token;

          var authLoginInput = new GluedIn.GluedInAuthModule();
          let signInRawData = {
            email: email_address,
            fullName: first_name + " " + last_name,
            userId: provider_auth_id,
            userName: "",
            profileImageUrl: picture,
            deviceId: "qfjadkfdsfh",
            deviceType: "android",
            type: "google",
            socialType: "signup",
            token: "",
            termConditionAccepted: true,
          };
          var userSignIpResponse = await authLoginInput.SocialSigninData(
            signInRawData
          );
          if (userSignIpResponse.status == 200) {
            if (userSignIpResponse.data.statusCode == 200) {
              var userModuleObj = new GluedIn.GluedInUserModule();
              var userConfigResponse = await userModuleObj.getUseConfig();
              if (
                userConfigResponse.status == 200 ||
                userSignIpResponse.status == 201
              ) {
                let following = userConfigResponse.data.data.following;
                localStorage.setItem("following", JSON.stringify(following));
              }
              /*$(
                    '<div class="alert alert-success success-alert" role="alert">  ' +
                      userSignIpResponse.data.message +
                      "</div>"
                  ).insertBefore(".first-input-box");
                  $("#signInForm").trigger("reset");*/
              window.location.href = "https://gluedin.io/web-app//home-feed.html";
            } else {
              $(
                '<div class="alert alert-danger error-alert" role="alert">  ' +
                  userSignIpResponse.data.message +
                  "</div>"
              ).insertBefore(".first-input-box");
            }
          } else {
            $(
              '<div class="alert alert-danger error-alert" role="alert">  ' +
                userSignIpResponse.data.message +
                "</div>"
            ).insertBefore(".first-input-box");
          }
        },
        function (error) {
          alert("Login cancelled by user");
        }
      );
  });

  /*End Google Login Module*/

  /*Start Facebook Login*/

  $(".login-with-facebook").on("click", function () {
    FB.login(
      function (response) {
        if (response.authResponse) {
          // Get the user profile data
          getFbUserData(response);
        } else {
          alert("Login cancelled by user");
        }
      },
      { scope: "email" }
    );
  });
  window.getFbUserData = function (accessTokenData) {
    var userAccessInfo = accessTokenData;
    FB.api(
      "/me",
      {
        locale: "en_US",
        fields: "id,first_name,last_name,email,link,gender,locale,picture",
      },
      async function (response) {
        let provider_auth_id = response.id;
        let email_address = response.email != undefined ? response.email : "";
        let first_name =
          response.first_name != undefined ? response.first_name : "";
        let last_name =
          response.last_name != undefined ? response.last_name : "";
        let picture =
          response.picture != undefined
            ? response.picture.data != undefined
              ? response.picture.data.url
              : ""
            : "";
        var authLoginInput = new GluedIn.GluedInAuthModule();
        let signInRawData = {
          email: email_address,
          fullName: first_name + " " + last_name,
          userId: provider_auth_id,
          userName: "",
          profileImageUrl: picture,
          deviceId: "qfjadkfdsfh",
          deviceType: "android",
          type: "facebook",
          socialType: "signup",
          token: "",
          termConditionAccepted: true,
        };
        var userSignIpResponse = await authLoginInput.SocialSigninData(
          signInRawData
        );
        if (userSignIpResponse.status == 200) {
          if (userSignIpResponse.data.statusCode == 200) {
            var userModuleObj = new GluedIn.GluedInUserModule();
            var userConfigResponse = await userModuleObj.getUseConfig();
            if (
              userConfigResponse.status == 200 ||
              userSignIpResponse.status == 201
            ) {
              let following = userConfigResponse.data.data.following;
              localStorage.setItem("following", JSON.stringify(following));
            }
            /*$(
                    '<div class="alert alert-success success-alert" role="alert">  ' +
                      userSignIpResponse.data.message +
                      "</div>"
                  ).insertBefore(".first-input-box");
                  $("#signInForm").trigger("reset");*/
            window.location.href = "https://gluedin.io/web-app//home-feed.html";
          } else {
            $(
              '<div class="alert alert-danger error-alert" role="alert">  ' +
                userSignIpResponse.data.message +
                "</div>"
            ).insertBefore(".first-input-box");
          }
        } else {
          $(
            '<div class="alert alert-danger error-alert" role="alert">  ' +
              userSignIpResponse.data.message +
              "</div>"
          ).insertBefore(".first-input-box");
        }
      }
    );
  };

  /*End Facebook Login*/
})(jQuery);
