(function ($) {
  "use strict";
  $(document).ready(function () {
    window.getNotificationList = async function () {
      var notificationModuleObj = new GluedIn.GluedInNotificationModule();

      var notificationModuleResponse =
        await notificationModuleObj.getNotificationList({
          limit: 20,
          offset: 1,
        });

      $(".screen-loader").hide();
      if (notificationModuleResponse.status == 200) {
        let notificationList = notificationModuleResponse.data.data;
        $("#notification-count").val(
          "(" + notificationModuleResponse.data.total + ")"
        );
        let notificationHtml = "";
        notificationList.forEach(function (contentInfo) {
          contentInfo.notifications.forEach(function (notificationInfo) {
            notificationHtml =
              '<div class="notification-box"><ul class="notification-box-ul"><li class="content-sec"><ul><li>' +
              getTime(contentInfo.date) +
              "</li><li>" +
              getDate(contentInfo.date) +
              '</li></ul><div class="text mt-t-10">' +
              notificationInfo.discription +
              '</div></li><li class="img-sec"><img src="' +
              notificationInfo.videoThumbnail +
              '"></li></ul></div>';
          });
        });
        $(".notification-box-parent").html(notificationHtml);
      } else {
        if (notificationModuleResponse.status == 401) {
          localStorage.clear();
          sessionStorage.clear();
          window.location.href = "https://gluedin.io/web-app//sign-in.html";
        }
      }
    };

    getNotificationList();

    function getTime(date) {
      if (typeof date !== "object") {
        date = new Date(date);
      }

      var seconds = Math.floor((new Date() - date) / 1000);
      var intervalType;

      var interval = Math.floor(seconds / 31536000);
      if (interval >= 1) {
        intervalType = "year";
      } else {
        interval = Math.floor(seconds / 2592000);
        if (interval >= 1) {
          intervalType = "month";
        } else {
          interval = Math.floor(seconds / 86400);
          if (interval >= 1) {
            intervalType = "day";
          } else {
            interval = Math.floor(seconds / 3600);
            if (interval >= 1) {
              intervalType = "hour";
            } else {
              interval = Math.floor(seconds / 60);
              if (interval >= 1) {
                intervalType = "minute";
              } else {
                interval = seconds;
                intervalType = "second";
              }
            }
          }
        }
      }

      if (interval > 1 || interval === 0) {
        intervalType += "s";
      }

      return interval + " " + intervalType;
    }

    function getDate(inputDate) {
      const monthNames = [
        "January",
        "February",
        "March",
        "April",
        "May",
        "June",
        "July",
        "August",
        "September",
        "October",
        "November",
        "December",
      ];
      const d = new Date(inputDate);
      return (
        d.getDate() + " " + monthNames[d.getMonth()] + " " + d.getFullYear()
      );
    }
  });
})(jQuery);
